#include <stdio.h>
#include <string.h>
#include <syslog.h>

#include "nntpd.h"
#include "aconfig.h"

#define _MAX_LINEBUF 256
#define _MAX_USERPASS 32
#define _MAX_REASON _MAX_LINEBUF-(2*_MAX_USERPASS)-4

const char * check_auth(CLIENT *client, CONFIG *cf, char *args) {
    FILE *FILE;
    char retbuf[_MAX_LINEBUF];
    char u[_MAX_USERPASS];
    char p[_MAX_USERPASS];
    char r[_MAX_REASON];

    if ( ! (FILE=fopen(args, "r")) ) {
	syslog(LOG_ERR,"Error opening password file %s (%m)", args); 
	return MSG_AUTH_ERR;
    }

    while( fgets(retbuf,_MAX_LINEBUF-1,FILE) ) {
	sscanf(retbuf,"%32[^:]:%32[^:]:%128[^\r\n]", u, p, r);

        if ( ! strcasecmp(u,client->username) ) {
            if ( ! strcasecmp(p,client->password) ) {
		if ( ! strncasecmp(r,"ok",2) ) {
               	    fclose(FILE);
		    client->authenticated++;
		    return MSG_AUTH_OK;
		}else if ( ! strncasecmp(r,"np",2) ) {
		    fclose(FILE);
		    client->authenticated++;
		    client->acl->post=0;
		    return MSG_AUTH_OK;
		}else{
               	    fclose(FILE);
		    sprintf(retbuf,"482 %s", r);
		    return strdup(retbuf);
		}
            }else{
		fclose(FILE);
		return MSG_AUTH_REJ;
	    }
        }

    }
    fclose(FILE);
    return MSG_AUTH_REJ;
}
