/*
 * NNTPSwitch PostgreSQL Authenticator
 * $Id: 
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <postgresql/libpq-fe.h>

#include "nntpd.h"
#include "aconfig.h"
#include "aprotos.h"
 
const char * check_auth(CLIENT *client, CONFIG *cf, char *conninfo) {
        PGconn     *conn;
        PGresult   *res;
	char	   tmp[512];

        /* Make a connection to the database */
        conn = PQconnectdb(conninfo);

        /* Check to see that the backend connection was successfully made */
        if (PQstatus(conn) != CONNECTION_OK)
        {
		syslog(LOG_ERR, "auth_pgsql: connect to database %s failed: %s", PQdb(conn), PQerrorMessage(conn));
		PQfinish(conn);
		return MSG_AUTH_ERR;
        }

	sprintf(tmp, "SELECT login FROM users WHERE login = '%s' AND password = '%s'",
			client->username,
			client->password);

        res = PQexec(conn, tmp);
        if (PQresultStatus(res) != PGRES_TUPLES_OK)
        {
		syslog(LOG_ERR, "auth_pgsql: select command failed: %s", PQerrorMessage(conn));
		PQfinish(conn);
		return MSG_AUTH_ERR;
        }

	if ( PQntuples(res) == 0 ) {
		PQclear(res);
		PQfinish(conn);
		return MSG_AUTH_REJ;
	}

	PQclear(res);
	PQfinish(conn);
	client->authenticated++;

	return MSG_AUTH_OK;
}
