/*
 * radius authorization for nntpswitch
 * original by ads of voicenet. big thanks!
 */

#include <radlib.h>
#include <stdio.h>
#include <string.h>
#include <syslog.h>

#include "nntpd.h"
#include "aconfig.h"
#include "aprotos.h"

const char * check_auth(CLIENT *client, CONFIG *cf, char *args) {
    struct rad_handle *radh;
    struct servent *rport;
    /* ADS - 20031222 - addition to see if client can post */
    size_t len;
    const void *data;
    char *rmessage = NULL;
    /* -- end -- */
    int port;
    char hostname[128];
    char server[128];
    char secret[128];
    struct sockaddr_in svraddr;
    int svraddrlen = sizeof(svraddr);

    if ( sscanf(args, "%128[^:]:%s", server, secret) != 2 ) {
	syslog(LOG_ERR,"Wrong argument syntax %s for auth_radius", args);
        return MSG_AUTH_ERR;
    }

    if ( !(radh = rad_auth_open()) ) {
	syslog(LOG_ERR, "auth_radius: rad_acct_open failed");
        return MSG_AUTH_ERR;
    }
 
    if ( (rport = getservbyname("radius","udp")) != NULL ) 
	port = ntohs(rport->s_port);
    else
	port = 1812;

    if ( rad_add_server(radh, server, port, secret, 5, 2) < 0 ) {
	syslog(LOG_ERR, "auth_radius: rad_add_server failed");
       	return MSG_AUTH_ERR;
    }
 
    if (rad_create_request(radh, RAD_ACCESS_REQUEST) < 0) {
	syslog(LOG_ERR, "auth_radius: rad_create_request failed");
        return MSG_AUTH_ERR;
    }
    
    gethostname(hostname, 128);
    getsockname(client->socket, (struct sockaddr *) &svraddr, &svraddrlen);

    rad_put_int(radh, RAD_NAS_PORT, client->id + 1);
    rad_put_int(radh, RAD_SERVICE_TYPE, RAD_LOGIN); 
    rad_put_string(radh, RAD_USER_NAME, strippat(client->username, client->auth->mask));
    rad_put_string(radh, RAD_USER_PASSWORD, client->password);
    rad_put_addr(radh, RAD_NAS_IP_ADDRESS, svraddr.sin_addr);
    rad_put_string(radh, RAD_NAS_IDENTIFIER, hostname);
 
    switch (rad_send_request(radh) ) {
	case RAD_ACCESS_ACCEPT:
	    syslog(LOG_DEBUG, "auth_radius: Successful Login for %s", client->username);

	    if ( rad_get_attr(radh, &data, &len) == RAD_FILTER_ID ) {
		rmessage = rad_cvt_string(data, len);
		if ( !strcmp(rmessage, "nopost") ) 
		    client->acl->post = 0;
		if ( rmessage != NULL) 
		    free(rmessage);
	    }

	    rad_close(radh);
	    client->authenticated++;
	    return MSG_AUTH_OK;
    }
    rad_close(radh);
    return MSG_AUTH_REJ;
}
