#include <stdio.h>
#include <string.h>
#include <syslog.h>

#include "aconfig.h"
#include "nntpd.h"
#include "aprotos.h"

#define _MAX_LINEBUF 256

const char * check_auth(CLIENT *client, CONFIG *cf, char *args) {
    char retbuf[_MAX_LINEBUF];
    char server[128];
    int port;
    char *un;

    if ( sscanf(args, "%128[^:]:%d", server, &port) != 2 ) {
	syslog(LOG_ERR,"Wrong argument syntax %s for auth_remote", args);
	return MSG_AUTH_ERR;
    }

    if ( connect_server_nntp(client, server, port, cf->ServerReadTimeout) ) {
	syslog(LOG_ERR,"Error connecting to authentication server!"); 
	return MSG_AUTH_ERR;
    }

    un = strippat(client->username, client->auth->mask);
    writeserver(client,"AUTHINFO USER %s", un);
    if ( readserver(client, retbuf, _MAX_LINEBUF) == NULL ) return MSG_AUTH_ERR;
    writeserver(client,"AUTHINFO PASS %s", client->password);
    if ( readserver(client, retbuf, _MAX_LINEBUF) == NULL ) return MSG_AUTH_ERR;

    if ( atoi(retbuf) == 281 ) {
	client->authenticated++;
	return MSG_AUTH_OK;
    }
    return strdup(retbuf);
}
