#! /bin/sh

PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
DAEMON=/usr/local/sbin/nntpswitchd
ARGS=
# uncomment this if you have a specific config file
#ARGS="-c /etc/nntpswitch/configs/0.10/nntpswitch.conf"
NAME=nntpswitchd
DESC="NNTPSwitch"
PIDFILE=/var/run/nntpswitchd.pid

test -x $DAEMON || exit 0

set -e

case "$1" in
  start)
	echo -n "Starting $DESC: "
	if [ -f $PIDFILE ]; then
	    echo -n "already running with pid "
	    echo `cat $PIDFILE`
	    exit 1
	fi
	$DAEMON $ARGS >/dev/null 2>&1
	echo $NAME
	;;
  stop)
	echo -n "Stopping $DESC: "
	if [ ! -f $PIDFILE ]; then
	    echo "not running"
	else
	    kill `cat $PIDFILE`
	    rm -f $PIDFILE >/dev/null 2>&1
	    echo $NAME
	fi
	;;
  reload)
	echo -n "Reloading $DESC: "
	if [ ! -f $PIDFILE ]; then
	    echo "not running"
	    exit 1
	fi
	kill -1 `cat $PIDFILE`
	echo $NAME
	;;
  restart)
	echo -n "Restarting $DESC: "
	if [ ! -f $PIDFILE ]; then
	    echo "not running"
	    exit 1
	fi
	kill `cat $PIDFILE`
	sleep 1
	$DAEMON $ARGS >/dev/null 2>&1
	echo $NAME
	;;
  config|test|configtest|check)
	$DAEMON -t $ARGS
	;;
  *)
	N=/etc/init.d/$NAME
	echo "Usage: $N {start|stop|reload|restart|test}" >&2
	exit 1
	;;
esac

exit 0

