#!/usr/bin/perl
#
# mkprotos.pl
#
# generate aprotos.h from all .c files given
#

my $usage = "Usage: $0 <directory>\n";
my $dir	  = shift @ARGV || ".";

my $top = <<TOP;
/* automatically generated by make config in $0 %s */
#ifndef APROTOS_H
#define APROTOS_H
#define PROTO
TOP

my $bot = <<BOT;
#endif
BOT

sub getprotos {
    my ($file) = shift;

    open(F,$file) || die "$file: $!\n";
    while(<F>) {
	chop;
        if ( m/^PROTO/ ) {
	    s/^PROTO\s+//g;
	    s/\s+\{$//g;
	    s/\s+$//g;
	    print "$_;\n";
	}
    }

    close F;
}



opendir(DIR,$dir) || die "Couldn't open $dir ($!)\n";

printf($top, scalar localtime(time) );

for( readdir(DIR) ) {
    next if ! m/\.c$/;
    getprotos("$dir/$_");
}

closedir(DIR);

printf $bot;
